﻿Imports System.Drawing.Drawing2D

<ToolboxBitmap(GetType(Panel))>
Public Class RPanel
    Dim _crn As Single
    Public Property CornerRadius As Single
        Get
            Return _crn
        End Get
        Set(ByVal value As Single)
            _crn = value
            Me.Invalidate()
        End Set
    End Property
    Private Sub RPanel_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load

    End Sub
    Protected Overrides Sub OnPaint(ByVal e As System.Windows.Forms.PaintEventArgs)
        MyBase.OnPaint(e)
        e.Graphics.SmoothingMode = SmoothingMode.HighQuality
        drawouterline(e.Graphics)

    End Sub
    Sub drawouterline(ByVal g As Graphics)
        g.InterpolationMode = InterpolationMode.HighQualityBicubic
        g.SmoothingMode = SmoothingMode.AntiAlias
        Dim rct As Rectangle = Me.ClientRectangle

        rct.Width -= 3
        rct.Height -= 3

        Using rr As GraphicsPath = RoundRect(rct, CornerRadius, CornerRadius, CornerRadius, CornerRadius)
            Using p As New Pen(Brushes.Black)
                g.DrawPath(p, rr)
            End Using
        End Using

    End Sub
    Private Function RoundRect(ByVal r As Rectangle, ByVal r1 As Single, ByVal r2 As Single, ByVal r3 As Single, ByVal r4 As Single) As GraphicsPath
        Dim x As Single = r.X, y As Single = r.Y, w As Single = r.Width, h As Single = r.Height
        Dim rr As New GraphicsPath()
        rr.AddBezier(x, y + r1, x, y, x + r1, y, _
         x + r1, y)
        rr.AddLine(x + r1, y, x + w - r2, y)
        rr.AddBezier(x + w - r2, y, x + w, y, x + w, y + r2, _
         x + w, y + r2)
        rr.AddLine(x + w, y + r2, x + w, y + h - r3)
        rr.AddBezier(x + w, y + h - r3, x + w, y + h, x + w - r3, y + h, _
         x + w - r3, y + h)
        rr.AddLine(x + w - r3, y + h, x + r4, y + h)
        rr.AddBezier(x + r4, y + h, x, y + h, x, y + h - r4, _
         x, y + h - r4)
        rr.AddLine(x, y + h - r4, x, y + r1)
        Return rr
    End Function

    Private Sub RPanel_Resize(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Resize
     
    End Sub
End Class
